package cn.com.tenlion.configcolumn.service.configcolumnset;

import cn.com.tenlion.configcolumn.pojo.dtos.configcolumngroup.ConfigColumnGroupDTO;
import cn.com.tenlion.configcolumn.pojo.vos.configcolumnset.ConfigColumnSetDisplayVO;
import cn.com.tenlion.configcolumn.pojo.vos.configcolumnset.ConfigColumnSetNameVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;
import cn.com.tenlion.configcolumn.pojo.dtos.configcolumnset.ConfigColumnSetDTO;
import cn.com.tenlion.configcolumn.pojo.vos.configcolumnset.ConfigColumnSetVO;
import cn.com.tenlion.configcolumn.pojo.bos.configcolumnset.ConfigColumnSetBO;
import cn.com.tenlion.configcolumn.pojo.pos.configcolumnset.ConfigColumnSetPO;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IConfigColumnSetService
 * @Description: 
 * @Author: CodeFactory
 * @Date: 2021-07-09 09:48:21
 * @Version: 3.0
 **/
public interface IConfigColumnSetService {

    /**
     * 删除
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改
     *
     * @param configColumnSetId
     * @param configColumnSetVO
     * @return
     */
    void update(String configColumnSetId, ConfigColumnSetVO configColumnSetVO);

    /**
     * 修改
     *
     * @param token
     * @param configColumnSetId
     * @param configColumnSetVO
     * @return
     */
    void update(String token, String configColumnSetId, ConfigColumnSetVO configColumnSetVO);

    /**
     * 详情
     *
     * @param params 参数Map
     * @return
     */
    ConfigColumnSetDTO get(Map<String, Object> params);

    /**
     * 详情
     *
     * @param configColumnSetId
     * @return
     */
    ConfigColumnSetDTO get(String configColumnSetId);

    /**
     * 详情
     *
     * @param params 参数Map
     * @return
     */
    ConfigColumnSetBO getBO(Map<String, Object> params);

    /**
     * 详情
     *
     * @param configColumnSetId
     * @return
     */
    ConfigColumnSetBO getBO(String configColumnSetId);

    /**
     * 详情
     *
     * @param params 参数Map
     * @return
     */
    ConfigColumnSetPO getPO(Map<String, Object> params);

    /**
     * 详情
     *
     * @param configColumnSetId
     * @return
     */
    ConfigColumnSetPO getPO(String configColumnSetId);

    /**
     * 列表
     *
     * @param params
     * @return
     */
    List<ConfigColumnGroupDTO> listToApp(String token, Map<String, Object> params);

    /**
     * 列表
     *
     * @param params
     * @return
     */
    List<ConfigColumnSetDTO> list(Map<String, Object> params);

    /**
     * 列表
     *
     * @param params
     * @return
     */
    List<ConfigColumnSetBO> listBO(Map<String, Object> params);

    /**
     * 列表
     *
     * @param params
     * @return
     */
    List<ConfigColumnSetPO> listPO(Map<String, Object> params);

    /**
     * 分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<ConfigColumnSetDTO>> listPage(ListPage page);

    /**
     * 统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    /**
     * 修改栏目的隐藏与显示
     * @param token
     * @param configColumnSetDisplayVO
     */
    void saveDisplay(String token, ConfigColumnSetDisplayVO configColumnSetDisplayVO);

    /**
     * 修改栏目的自定义名称
     * @param token
     * @param configColumnSetNameVO
     */
    void saveName(String token, ConfigColumnSetNameVO configColumnSetNameVO);

    /**
     * 查询栏目的自定义名称
     * @param token
     * @param configColumnId
     */
    ConfigColumnSetDTO getSetName(String token, String configColumnId);

    /**
     * 查询栏目的自定义隐藏
     * @param token
     * @param configColumnId
     */
    ConfigColumnSetDTO getSetDisplay(String token, String configColumnId);

    /**
     * 查询栏目的自定义名称
     * @param userId
     * @param configColumnId
     */
    ConfigColumnSetDTO getSetNameByUserId(String userId, String configColumnId);

    /**
     * 查询栏目的自定义隐藏
     * @param userId
     * @param configColumnId
     */
    ConfigColumnSetDTO getSetDisplayByUserId(String userId, String configColumnId);

}